net.sf.saxon.tree.util

## Class Navigator.BaseEnumeration

- java.lang.Object
- - net.sf.saxon.tree.iter.AxisIteratorImpl
  - - net.sf.saxon.tree.util.Navigator.BaseEnumeration

- All Implemented Interfaces:
    SequenceIterator<NodeInfo>, AxisIterator<NodeInfo>, UnfailingIterator<NodeInfo>
  Direct Known Subclasses:
    Navigator.AncestorEnumeration, Navigator.DescendantEnumeration, Navigator.FollowingEnumeration, Navigator.PrecedingEnumeration
  Enclosing class:
    Navigator

      public abstract static class Navigator.BaseEnumeration
      extends AxisIteratorImpl

  BaseEnumeration is an abstract implementation of an AxisIterator, it simplifies the implementation of the underlying AxisIterator by requiring it to provide only two methods: advance(), and getAnother().

  BaseEnumeration takes responsibility for incrementing position when next() is called. The advance() method in a subclass should therefore not modify position.

- - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.tree.iter.AxisIteratorImpl

      `current, position`

    - ### Fields inherited from interface net.sf.saxon.om.SequenceIterator

      `GROUNDED, LAST_POSITION_FINDER, LOOKAHEAD`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Navigator.BaseEnumeration()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `abstract void` | `advance()` The advance() method must be provided in each concrete implementation.
    `abstract AxisIterator` | `getAnother()` Get another iterator over the same sequence of items, positioned at the start of the sequence.
    `NodeInfo` | `next()` Get the next item in the sequence.

    - ### Methods inherited from class net.sf.saxon.tree.iter.AxisIteratorImpl

      `atomize, close, current, getProperties, getStringValue, iterateAxis, moveNext, position`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### Navigator.BaseEnumeration

          public Navigator.BaseEnumeration()

  - ### Method Detail

    - #### next

          public final NodeInfo next()

      Description copied from interface: `UnfailingIterator`
      Get the next item in the sequence.
      Returns:
        the next Item. If there are no more nodes, return null.

    - #### advance

          public abstract void advance()

      The advance() method must be provided in each concrete implementation. It must leave the variable current set to the next node to be returned in the iteration, or to null if there are no more nodes to be returned.

    - #### getAnother

          public abstract AxisIterator getAnother()

      Description copied from interface: `UnfailingIterator`
      Get another iterator over the same sequence of items, positioned at the start of the sequence. It must be possible to call this method at any time, whether none, some, or all of the items in the original iterator have been read. The method is non-destructive: it does not change the state of the original iterator.
      Returns:
        a new iterator over the same sequence

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.